## -*- mode: Makefile -*-
## @configure_input@
##
## Copyright (c) 2000 University of Utah and the Flux Group.
## All rights reserved.
## 
## This file is part of Clack.
## 
## Clack is free software, also known as "open source."  You can redistribute
## it and/or modify it under the terms of the GNU General Public License
## (GPL), version 2, as published by the Free Software Foundation (FSF).
## 
## Clack is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
## FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
## received a copy of the GPL along with Clack; see the file COPYING.  If
## not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
## 
## Clack is modelled on and includes some code fragments from MIT's Click
## system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
## 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
## 
## Users are requested, but not required, to send to csl-dist@cs.utah.edu any
## improvements that they make and grant Univ. of Utah redistribution rights.
##

# This makefile is used in conjunction with the Knit-generated makefile
# code when generating usermode Clack routers.

# This rule goes first to make it the default
default	::

.SUFFIXES:
CFLAGS = -O2 -g
AR = /usr/bin/ar
RM = /bin/rm -f
RENAME_DOT_O_FILES = rename_dot_o_files

## If -s is passed to make, make things quiet but echo an explanation of
## what make is doing at each stage.

ifeq (s,$(findstring s,$(MAKEFLAGS)))
KNIT_QUIET_MAKE_INFORM=@echo
ARFLAGS=r  ## drop the v from the default
else
KNIT_QUIET_MAKE_INFORM=@true
endif

# This makefile includes the (giant) makefile generated by Knit
# which should define OSKITDIR, BUILDDIR and KNIT_LIBS

include knit_generated.mk

# Now we build the router and initialisation code.

knit_inits.o : knit_inits.c
	$(KNIT_QUIET_MAKE_INFORM) Building $@
	$(CC) $(CFLAGS) -o $@ -c $^

glue.o : $(KNITDIR)/clack/c/glue.c
	$(KNIT_QUIET_MAKE_INFORM) Building $@
	$(CC) $(CFLAGS) -o $@ -c $^

router : knit_inits.o glue.o $(KNIT_LIBS)
	$(KNIT_QUIET_MAKE_INFORM) Building $@
	$(CC) $(LDFLAGS) -o $@ \
	  knit_inits.o glue.o \
	  -Xlinker --start-group $(KNIT_LIBS) -Xlinker --end-group \
	  -lpcap
	size $@

# The router is one of our default targets.
default :: router

clean :: 
	$(RM) router knit_inits.o
clean :: 
	$(RM) $(KNIT_LIBS)
clean :: 
	$(RM) *_anon_*.c
clean :: 
	find . -name '*.[do]' | xargs $(RM)
clean :: 
	find . -name 'rename*' | xargs $(RM)
clean :: 
	find . -name '*xxx' | xargs $(RM)
clean :: 
	find . -name '*yyy' | xargs $(RM)

# End of file
